<template>
	<f7-page name="cctvview" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
            <f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">{{ user.residential != null ? user.residential.name : 'CCTV' }}</f7-nav-title>
            <f7-nav-title-large v-if="cctv">{{ cctv.name }}</f7-nav-title-large>
		</f7-navbar>
		<f7-block v-if="cctv">
			<img v-if="streamImg" :src="streamImg" style="width:100%;">
			<div v-else class="preloader color-green"></div>
		</f7-block>
	</f7-page>
</template>
<script>
import Vue from 'vue';
import Url from 'url-parse';
import { mapGetters } from 'vuex';
import { initial } from '../js/utils';
export default {
	name: 'CCTV',
	data(){
		return{
			interval: null,
			streamImg: ''
		};
	},
	computed: {
		...mapGetters('auth', ['user', 'token']),
		...mapGetters('cctv', [
            'cctv'
		])
	},
	methods: {
        initial,	
		onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

			self.$store.dispatch('cctv/viewCCTV', {
                id: self.$f7route.params.id,
                only: 'id,name,url,residential.name'
            }).then(() => {

				self.interval = setInterval(()=>{
					Vue.http.get('/cctv/stream/'+self.$f7route.params.id, {
						responseType: 'arraybuffer',
						headers: {
							Authorization: 'Bearer ' + self.token.access_token
						}
					}).then((response)=>{
						self.streamImg = 'data:image/jpeg;base64,'+ new Buffer(response, 'binary').toString('base64');
					});
				},3000);

				app.preloader.hide();
            });
		},
		onPageBeforeOut(){
			const self = this;
			const app = self.$f7;

			self.interval = null;
			
		}
	},
	mounted(){
		const self = this;
		const app = self.$f7;
		const $$ = self.$$;
	}
}
</script>
